db $42
JMP Mario : JMP Return : JMP Return : JMP SpriteV : JMP SpriteH : JMP Mario : JMP Return : JMP Return : JMP Return : JMP Return

Mario:
	JSR Hit
	JSR SpriteKiller
	RTL


SpriteV:
	LDA $1686,x
	AND #$04
	BNE +
	LDA $14C8,x
	CMP #$09
	BCC +
	CMP #$0B
	BCS +
	LDA $0F
	CMP #$02
	BEQ +
	JSR SprMain
+
	RTL

SpriteH:
	LDA $14C8,x
	CMP #$0A
	BNE +
	JSR SprMain
+
	RTL

SprMain:
	REP #$20
	LDA $0A
	STA $9A
	LDA $0C
	STA $98
	LDA $0F
	PHA
	SEP #$20
	JSR Hit
	PLA
	STA $0F
	PLA
	STA $10
	JSR SpriteKiller
	RTS

Return:
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Hit:
	LDA $03
	PHA
	LDX #$03
-	
	LDA $1699,x
	BEQ +
	DEX
	BPL -
	DEC $18CD
	LDA #$FC
	TRB $18CD
	LDX $18CD
	LDA $1699,x
	CMP #$07
	BNE +
	JSR ResetTurnblock
+
	LDA #$0F
	TRB $98
	TRB $9A
	LDA #$03	; question block
	STA $1699,x
	LDA #$01
	STA $169D,x
	LDA $98
	STA $16A1,x
	LDA $99
	STA $16A9,x
	LDA $9A
	STA $16A5,x
	LDA $9B
	STA $16AD,x
	LDA #$C0
	STA $16B1,x
	LDA #$00
	STA $16B5,x
	LDA #$0D	; used block
	STA $16C1,x
	LDA #$08
	STA $16C5,x
	LDA $1933
	LSR
	ROR
	STA $16C9,x
	LDA #$0E
	STA $1901,x

	LDA #$09	; invisible solid block
	STA $9C
	JSL $00BEB0

	; give bridge builder item
	STZ $0DC2
	PLA
	STA $03
	AND #$07
	INC
	STA $0EFA

	RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteKiller:	LDX #$03		; disassembled from original smb3.bin
.C_8213		LDA $16CD,x
		BEQ .C_821C
		DEX 
		BPL .C_8213
		INX 
.C_821C		LDA $9A
		STA $16D1,x
		LDA $9B
		STA $16D5,x
		LDA $98
		STA $16D9,x
		LDA $99
		STA $16DD,x
		LDA $1933
		BEQ .C_8253
		LDA $9A
		SEC 
		SBC $26
		STA $16D1,x
		LDA $9B
		SBC $27
		STA $16D5,x
		LDA $98
		SEC 
		SBC $28
		STA $16D9,x
		LDA $99
		SBC $29
		STA $16DD,x
.C_8253		LDA #$01
		STA $16CD,x
		LDA #$06
		STA $18F8,x
		RTS

ResetTurnblock:	LDA $9A			; from Custom Bounce Block patch's SMB3Brick.asm
		PHA
		LDA $9B
		PHA
		LDA $98
		PHA
		LDA $99	
		PHA
		LDA $16A5,Y
		STA $9A
		LDA $16AD,Y
		STA $9B
		LDA $16A1,Y
		CLC
		ADC #$0C
		AND #$F0
		STA $98
		LDA $16A9,Y
		ADC #$00
		STA $99
		LDA $16C1,Y
		STA $9C
		LDA $04
		PHA
		LDA $05
		PHA
		LDA $06
		PHA
		LDA $07
		PHA
		JSL $00BEB0
		PLA 
		STA $07
		PLA 
		STA $06
		PLA
		STA $05
		PLA 
		STA $04
		PLA 
		STA $99
		PLA 
		STA $98
		PLA 
		STA $9B
		PLA 
		STA $9A
		RTS
